#include <time.h>
#include <iostream>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include "CifBuilder.h"

int main(int argc, char ** argv) {
  if (argc != 3) {
    cerr << "Usage: " << argv[0] 
	 << " <object filename> <datablock name>" << endl;
    exit(0);
  }
  CifBuilder cb(argv[1]);
  cb.BuildDictionaryList();
  cb.SetContext(argv[2]);

  cout << "Get everthing ... individually ..." << endl << endl;

  string title = cb.GetDictionaryTitle();
  string version = cb.GetDictionaryVersion(); 
  string description = cb.GetDictionaryDescription();
  vector<string> historyVersion;
  cb.GetDictionaryHistoryVersion(historyVersion);
  vector<string> historyUpdate;
  cb.GetDictionaryHistoryUpdate(historyUpdate);
  vector<string> historyRevision;
  cb.GetDictionaryHistoryRevision(historyRevision);
  vector<string> subcategories;
  cb.GetDictionarySubcategories(subcategories);
  vector<string> categories;
  cb.GetDictionaryCategories(categories);
  vector<string> items;
  cb.GetDictionaryItems(items);
  vector<string> methods;
  cb.GetDictionaryMethods(methods);
  vector<string> methodsId;
  cb.GetDictionaryMethodsId(methodsId);
  vector<string> methodsList;
  cb.GetDictionaryMethodsList(methodsList);
  vector<string> methodsListDetail;
  cb.GetDictionaryMethodsListDetail(methodsListDetail);
  vector<string> methodsListInline;
  cb.GetDictionaryMethodsListInline(methodsListInline);
  vector<string> methodsListCode;
  cb.GetDictionaryMethodsListCode(methodsListCode);
  vector<string> methodsListLanguage;
  cb.GetDictionaryMethodsListLanguage(methodsListLanguage);
  vector<string> categoryGroupList;
  cb.GetDictionaryCategoryGroupList(categoryGroupList);
  vector<string> categoryGroupListParents;
  cb.GetDictionaryCategoryGroupListParents(categoryGroupListParents);
  vector<string> categoryGroupListDescription;
  cb.GetDictionaryCategoryGroupListDescription(categoryGroupListDescription);
  vector<string> itemStructureListCode;
  cb.GetDictionaryItemStructureListCode(itemStructureListCode);
  vector<string> itemStructureListIndex;
  cb.GetDictionaryItemStructureListIndex(itemStructureListIndex);
  vector<string> itemStructureListDimension;
  cb.GetDictionaryItemStructureListDimension(itemStructureListDimension);
  vector<string> itemTypeListCode;
  cb.GetDictionaryItemTypeListCode(itemTypeListCode);
  vector<string> itemTypeListPrimitiveCode;
  cb.GetDictionaryItemTypeListPrimitiveCode(itemTypeListPrimitiveCode);
  vector<string> itemTypeListConstruct;
  cb.GetDictionaryItemTypeListConstruct(itemTypeListConstruct);
  vector<string> itemTypeListDetail;
  cb.GetDictionaryItemTypeListDetail(itemTypeListDetail);
  vector<string> itemUnitsListCode;
  cb.GetDictionaryItemUnitsListCode(itemUnitsListCode);
  vector<string> itemUnitsListDetail;
  cb.GetDictionaryItemUnitsListDetail(itemUnitsListDetail);
  vector<string> itemUnitsConversionOperator;
  cb.GetDictionaryItemUnitsConversionOperator(itemUnitsConversionOperator);
  vector<string> itemUnitsConversionFactor;
  cb.GetDictionaryItemUnitsConversionFactor(itemUnitsConversionFactor);
  vector<string> itemUnitsConversionFromCode;
  cb.GetDictionaryItemUnitsConversionFromCode(itemUnitsConversionFromCode);
  vector<string> itemUnitsConversionToCode;
  cb.GetDictionaryItemUnitsConversionToCode(itemUnitsConversionToCode);

  uWord b = items.size();
  vector<string> regexes;
  for (uWord a = 0; a < b; a++) {
    regexes.push_back(cb.GetItemRegex(items[a].c_str()));
    if (regexes[a].empty())
    {
        cout << a << ": " << "(null)" << endl;
    }
    else
    {
        cout << a << ": " << regexes[a] << endl;
    }
  }
  uWord i;
  cout << "Title: " << title << endl;
  cout << "Version: " << version << endl;
  if (description.empty())
  {
      cout << "Description: " << "(null)" << endl;
  }
  else
  {
      cout << "Description: " << description << endl;
  }
  cout << "HistoryVersion: (" << historyVersion.size() << ")" << endl;
  for (i = 0; i < historyVersion.size(); i++) {
    cout << "  #" << i << " : " << historyVersion[i] << endl;
    historyVersion[i].clear();
  }
  historyVersion.clear();
  cout << "HistoryUpdate: (" << historyUpdate.size() << ")" << endl;
  for (i = 0; i < historyUpdate.size(); i++) { 
    cout << "  #" << i << " : " << historyUpdate[i] << endl;
    historyUpdate[i].clear();
  }
  historyUpdate.clear();
  cout << "HistoryRevision: (" << historyRevision.size() << ")" << endl;
  for (i = 0; i < historyRevision.size(); i++) {
    cout << "  #" << i << " : " << historyRevision[i] << endl;
    historyRevision[i].clear();
  }
  historyRevision.clear();

  cout << "Categories: (" << categories.size() << ")" << endl;
  for (i = 0; i < categories.size(); i++) {
    cout << "  #" << i << " : " << categories[i] << endl;
    categories[i].clear();
  }
  categories.clear();
  cout << "SubCategories: (" << subcategories.size() << ")" << endl;
  for (i = 0; i < subcategories.size(); i++) {
    cout << "  #" << i << " : " << subcategories[i] << endl;
    subcategories[i].clear();
  }
  subcategories.clear();
  cout << "Items: (" << items.size() << ")" << endl;
  for (i = 0; i < items.size(); i++) {
    cout << "  #" << i << " : " << items[i] << endl;
    items[i].clear();
  }
  items.clear();
  cout << "MethodsDB: (" << methods.size() << ")" << endl;
  for (i = 0; i < methods.size(); i++)
    cout << "  #" << i << " : " << methods[i] << endl;
  cout << "MethodsID: (" << methodsId.size() << ")" << endl;
  for (i = 0; i < methodsId.size(); i++)
    cout << "  #" << i << " : " << methodsId[i] << endl;
  cout << "MethodsList: (" << methodsList.size() << ")" << endl;
  for (i = 0; i < methodsList.size(); i++)
    cout << "  #" << i << " : " << methodsList[i] << endl;
  cout << "MethodsListDetail: (" << methodsListDetail.size() << ")" << endl;
  for (i = 0; i < methodsListDetail.size(); i++)
    cout << "  #" << i << " : " << methodsListDetail[i] << endl;
  cout << "MethodsListInline: (" << methodsListInline.size() << ")" << endl;
  for (i = 0; i < methodsListInline.size(); i++)
    cout << "  #" << i << " : " << methodsListInline[i] << endl;
  cout << "MethodsListCode: (" << methodsListCode.size() << ")" << endl;
  for (i = 0; i < methodsListCode.size(); i++)
    cout << "  #" << i << " : " << methodsListCode[i] << endl;
  cout << "MethodsListLanguage: (" << methodsListLanguage.size() << ")" << endl;
  for (i = 0; i < methodsListLanguage.size(); i++)
    cout << "  #" << i << " : " << methodsListLanguage[i] << endl;

  cout << "CategoryGroupList: (" << categoryGroupList.size() << ")" << endl;
  for (i = 0; i < categoryGroupList.size(); i++)
    cout << "  #" << i << " : " << categoryGroupList[i] << endl;

  cout << "CategoryGroupListParents: (" << categoryGroupListParents.size() << ")" << endl;
  for (i = 0; i < categoryGroupListParents.size(); i++)
    cout << "  #" << i << " : " << categoryGroupListParents[i] << endl;

  cout << "CategoryGroupListDescription: (" << categoryGroupListDescription.size() << ")" << endl;
  for (i = 0; i < categoryGroupListDescription.size(); i++)
    cout << "  #" << i << " : " << categoryGroupListDescription[i] << endl;

  cout << "ItemStructureListCode: (" << itemStructureListCode.size() << ")" << endl;
  for (i = 0; i < itemStructureListCode.size(); i++)
    cout << "  #" << i << " : " << itemStructureListCode[i] << endl;
  cout << "ItemStructureListIndex: (" << itemStructureListIndex.size() << ")" << endl;
  for (i = 0; i < itemStructureListIndex.size(); i++)
    cout << "  #" << i << " : " << itemStructureListIndex[i] << endl;
  cout << "ItemStructureListDimension: (" << itemStructureListDimension.size() << ")" << endl;
  for (i = 0; i < itemStructureListDimension.size(); i++)
    cout << "  #" << i << " : " << itemStructureListDimension[i] << endl;

  cout << "ItemTypeListCode: (" << itemTypeListCode.size() << ")" << endl;
  for (i = 0; i < itemTypeListCode.size(); i++)
    cout << "  #" << i << " : " << itemTypeListCode[i] << endl;
  cout << "ItemTypeListPrimitiveCode: (" << itemTypeListPrimitiveCode.size() << ")" << endl;
  for (i = 0; i < itemTypeListPrimitiveCode.size(); i++)
    cout << "  #" << i << " : " << itemTypeListPrimitiveCode[i] << endl;
  cout << "ItemTypeListConstruct: (" << itemTypeListConstruct.size() << ")" << endl;
  for (i = 0; i < itemTypeListConstruct.size(); i++)
    cout << "  #" << i << " : " << itemTypeListConstruct[i] << endl;
  cout << "ItemTypeListDetail: (" << itemTypeListDetail.size() << ")" << endl;
  for (i = 0; i < itemTypeListDetail.size(); i++)
    cout << "  #" << i << " : " << itemTypeListDetail[i] << endl;

  cout << "ItemUnitsListCode: (" << itemUnitsListCode.size() << ")" << endl;
  for (i = 0; i < itemUnitsListCode.size(); i++)
    cout << "  #" << i << " : " << itemUnitsListCode[i] << endl;
  cout << "ItemUnitsListDetail: (" << itemUnitsListDetail.size() << ")" << endl;
  for (i = 0; i < itemUnitsListDetail.size(); i++)
    cout << "  #" << i << " : " << itemUnitsListDetail[i] << endl;

  cout << "ItemUnitsConversionOperator: (" << itemUnitsConversionOperator.size() << ")" << endl;
  for (i = 0; i < itemUnitsConversionOperator.size(); i++)
    cout << "  #" << i << " : " << itemUnitsConversionOperator[i] << endl;
  cout << "ItemUnitsConversionFactor: (" << itemUnitsConversionFactor.size() << ")" << endl;
  if (!itemUnitsConversionFactor.empty())
    for (i = 0; i < itemUnitsConversionFactor.size(); i++)
      if (!itemUnitsConversionFactor[i].empty())
        cout << "  #" << i << " : " << itemUnitsConversionFactor[i] << endl;

  cout << "ItemUnitsConversionFromCode: (" << itemUnitsConversionFromCode.size() << ")" << endl;
   if (!itemUnitsConversionFromCode.empty())
     for (i = 0; i < itemUnitsConversionFromCode.size(); i++)
      if (!itemUnitsConversionFromCode[i].empty())
        cout << "  #" << i << " : " << itemUnitsConversionFromCode[i] << endl;

  cout << "ItemUnitsConversionToCode: (" << itemUnitsConversionToCode.size() << ")" << endl;
   if (!itemUnitsConversionToCode.empty())
     for (i = 0; i < itemUnitsConversionToCode.size(); i++)
      if (!itemUnitsConversionToCode[i].empty())
        cout << "  #" << i << " : " << itemUnitsConversionToCode[i] << endl;


  cout << "Done!" << endl;
  exit(0);
}





